//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//Pierwsza staa to numer ID ikonki. Warto jest przypadkowa
//Jeeli Twj program wywietla wicej ni jedn na raz
//to musisz kadej ikonce przypisa inny numer.
//Staa char* zawiera tekst jaki pojawi si po najechaniu
//myszk na ikonk.
//Ostatnia staa to zdefiniowany przez uytkownika komunikat
//ktry zostanie wysany do naszego okna przy zdarzeniu dotyczcym
//naszej ikonki

const int IDC_TRAY1      = 1005;
const char *HINT_MESSAGE = "Tekst nad ikonk";
const int WM_TRAYNOTIFY  = WM_USER + 1001;

#include <shellapi.h>
#include "mainform.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    // aduje ikonk z pliku RES
    TrayIcon = new Graphics::TIcon;
    TrayIcon->Handle=LoadImage(HInstance,
                              "LITTLEICON",
                              IMAGE_ICON,
                              0,0,
                              0);

    // Wywietla ikonk obok zegara
    AddIcon();
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
    // Usuwa ikonk i kasuje wskanik TIcon, ktry stworzylimy
    RemoveIcon();
    delete TrayIcon;
}

void __fastcall TForm1::WMTrayNotify(TMessage &Msg)
{
        //LParam okrela typ komunikatu.
        //Przy naciniciu prawego przycisku pokazuje si menu.
        //Podwjne kliknicie lewym powoduje pokazanie formy i
        //ukrycie ikonki.

    switch(Msg.LParam)
    {
        case WM_RBUTTONUP:
  // kiedy prawy klawisz zostanie zwolniony pobiera pozycj kursora
  // i wywietla menu. SetForegroundWindow i PostMessage naprawiaj
  // bd systemu operacyjnego.
            POINT WinPoint;
            GetCursorPos(&WinPoint);
            SetForegroundWindow(Handle);
            PopupMenu1->Popup(WinPoint.x,WinPoint.y);
            PostMessage(Handle, WM_NULL, 0,0);
            break;
        case WM_LBUTTONDBLCLK:
            RemoveIcon();
            ShowWindow(Application->Handle, SW_SHOW);
            Visible = true;
            break;
    }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::UnloadBtnClick(TObject *Sender)
{
    // koczy program po naciniciu "Zakocz"
    Application->Terminate();
}

void __fastcall TForm1::AddIcon()
{
    // uywa funkcji Shell_NotifyIcon
    // eby doda ikonk do SysTray.
    NOTIFYICONDATA IconData;
    IconData.cbSize = sizeof(NOTIFYICONDATA);
    IconData.uID    = IDC_TRAY1;
    IconData.hWnd   = Handle;
    IconData.uFlags = NIF_MESSAGE|NIF_ICON|NIF_TIP;
    IconData.uCallbackMessage = WM_TRAYNOTIFY;
    lstrcpy(IconData.szTip, HINT_MESSAGE);
    IconData.hIcon  = TrayIcon->Handle;

    Shell_NotifyIcon(NIM_ADD,&IconData);
}

void __fastcall TForm1::RemoveIcon()
{
    NOTIFYICONDATA IconData;
    IconData.cbSize = sizeof(NOTIFYICONDATA);
    IconData.uID    = IDC_TRAY1;
    IconData.hWnd   = Handle;
    IconData.hIcon  = TrayIcon->Handle;

    Shell_NotifyIcon(NIM_DELETE,&IconData);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    // Przy prbie zamknicia aplikacji, ukryta zostaje gwna forma,
    // w SysTray zostaje umieszczona ikonka, a program dalej dziaa.
    if(!Application->Terminated)
    {
        AddIcon();
        ShowWindow(Application->Handle, SW_HIDE);
        Visible = false;
        Action = caNone;
    }
}
//---------------------------------------------------------------------------
