//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "RecordUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    MediaID = 0;
    ComboBox1->ItemIndex = 0;
    ComboBox2->ItemIndex = 0;
    ComboBox3->ItemIndex = 0;
}

void __fastcall TForm1::MMMcnotify(TMessage &Msg)
{
    TForm::Dispatch(&Msg);
}

// otwiera urzdzenie wave dla nowego pliku
int TForm1::MCIWavOpenNew()
{
  MCI_OPEN_PARMS mciOp;

  // Okrela typ urzdzenia
  mciOp.lpstrDeviceType = "waveaudio";

  // Okrela nowy plik urzywajc pustego stringu
  mciOp.lpstrElementName = "";

  // Otwiera urzdzenie MCI
  long int result = mciSendCommand(0, MCI_OPEN, MCI_NOTIFY |
                                   MCI_OPEN_ELEMENT | MCI_OPEN_TYPE,
                                   (LPARAM)&mciOp);

  // Zwraca zero jeeli udao si
  if (result == 0) return mciOp.wDeviceID;
  else return 0;
}

// rozpoczcie nagrywania
long int TForm1::MCIWavRecordNew(int MediaID)
{
    MCI_RECORD_PARMS mciRp;

    mciRp.dwCallback = MAKELONG(Handle, 0);

    // zaczyna nagrywa
    long int result = mciSendCommand(MediaID, MCI_RECORD,
                                     MCI_NOTIFY, (LONG)&mciRp);

    // jeeli wszystko dobrze to wynik = 0
    if (result != 0)
        mciSendCommand(MediaID, MCI_CLOSE, 0, NULL);
    return result;
}


// ta funkcja zatrzymuje proces nagrywania
long int TForm1::MCIWavStop(int MediaID)
{
    MCI_GENERIC_PARMS mciGp;
    long int result = mciSendCommand(MediaID, MCI_STOP,
                                     MCI_NOTIFY, (LONG)&mciGp);

    // jeeli wszystko dobrze to wynik = 0
    if (result != 0)
        mciSendCommand(MediaID, MCI_CLOSE, 0, NULL);
    return result;
}

// odtwarza nagrane dane
long int TForm1::MCIWavPlayRecording(int MediaID)
{
    MCI_PLAY_PARMS mciPp;
    mciPp.dwFrom = 0L;
    long int result = mciSendCommand(MediaID, MCI_PLAY, MCI_FROM |
                                     MCI_WAIT, (LONG)&mciPp);
    if (result != 0)
    mciSendCommand(MediaID, MCI_CLOSE, 0, NULL);
    return result;
}

long int TForm1::MCIWavSave(int MediaID, AnsiString FileName)
{
    MCI_SAVE_PARMS mciSp;
    mciSp.lpfilename = FileName.c_str();
    long int result = mciSendCommand(MediaID, MCI_SAVE,
             MCI_SAVE_FILE | MCI_WAIT,
                                     (LONG)&mciSp);
    if (result != 0)
        mciSendCommand(MediaID, MCI_CLOSE, 0, NULL);
    return result;
}


// Metody pokazujce uycie powyszych funkcji
//---------------------------------------------------------------------------
void __fastcall TForm1::NagrywajClick(TObject *Sender)
{
    if (MediaID != 0) mciSendCommand(MediaID, MCI_CLOSE, 0, NULL);

    MediaID = MCIWavOpenNew();

    long int result = MCIWavQuality(MediaID);

    if (MediaID != 0)
    {
        long int result1 = MCIWavRecordNew(MediaID);
        if (result1 != 0) ShowMessage("Bd nagrywania");
    }
    else ShowMessage("Bd otwarcia");
}

void __fastcall TForm1::StopClick(TObject *Sender)
{
    long int result = MCIWavStop(MediaID);
    if (result != 0) ShowMessage("Bd przy zatrzymaniu");
}

void __fastcall TForm1::OdtwarzajClick(TObject *Sender)
{
    if (MediaID != 0)
    {
        long int result = MCIWavPlayRecording(MediaID);
    if (result != 0) ShowMessage("Bd odtwarzania");
    }
    else ShowMessage("Nie ma otwartego urzdzenia");
}

void __fastcall TForm1::ZapiszClick(TObject *Sender)
{
    if (MediaID != 0)
    {
        if (SaveDialog1->Execute())
        {
           long int result = MCIWavSave(MediaID, SaveDialog1->FileName);
    if (result != 0) ShowMessage("Error Saving");
        }
    }
    else ShowMessage("Nie ma otwartego urzdzenia");
}

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    if (MediaID != 0) mciSendCommand(MediaID, MCI_CLOSE, 0, NULL);
}


long int TForm1::MCIWavQuality(int MediaID)
{
    MCI_WAVE_SET_PARMS mciwsp;
    mciwsp.wBitsPerSample = ComboBox1->Text.ToInt();
    mciwsp.nSamplesPerSec = ComboBox2->Text.ToInt();
    if (ComboBox3->Text == "Stereo") mciwsp.nChannels = 2;
        else mciwsp.nChannels = 1;

    long int result = mciSendCommand(MediaID, MCI_SET,
     MCI_WAVE_SET_BITSPERSAMPLE | MCI_WAVE_SET_SAMPLESPERSEC
                     | MCI_WAVE_SET_CHANNELS, (LPARAM)&mciwsp);

    // jeeli wszystko dobrze to wynik = 0
    if (result != 0)
        mciSendCommand(MediaID, MCI_CLOSE, 0, NULL);
    return result;
}







