//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "paleta_unit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
//Paleta jest programem, ktry napisaem, aby uatwi sobie prac
//z kolorami. Pomaga ona w szybkim wybieraniu kolorw i wstawianiu ich
//do programw (np. C++ Builder, czy te HomeSite)

//Krtka instrukcja:
//Klikajc prawym przyciskiem na palecie kolorw zobaczymy
//podrczne menu. Po zaznaczeniu opcji 'Kopiuj przy klikniciu'
//program bdzie kopiowa kolor do schowka automatycznie po
//klikniciu myszk na palecie. Kiedy opcja jest niezaznaczona
//trzeba klikn na przycisk pod palet, eby skopiowa kolor.
//Opcje 'Homesite' i 'BCB' powoduj konwersj koloru na odpowiedni
//format. Klikajc prawym przyciskiem na SpeedButton1 poniej palety
//zmieniamy rozmieszczenie kolorw na palecie.
//I to w zasadzie wszystko.

//Autor: Maciej Frankiewicz Data 4.08.99

//Strefa C++ Builder'a
//http://wilczarz.cavern.com.pl/cbuilder/
//e-mail: maciek@konin.lm.pl

//Program jest cakowicie freeware, mona go kopiowa,
//edytowa, jednym sowem robi co si tylko podoba...
//Jeli rozwizalibycie co inaczej, to dajcie zna;
//moecie rwnie napisa, co sdzicie o tym "programiku"...

//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

//Ustawia styl na nieprzeroczysty
PaintBox1->ControlStyle = PaintBox1->ControlStyle << csOpaque;

//zmienna Blokada mwi, czy kolor Panel1 ma by cay czas aktualizowany
Blokada = true;

//Bitmapa MemBitmap suy w celu przyspiesznia rysowania
Rozmiar = 64;
Dzielnik = 256 / (float) Rozmiar;

PaintBox1->Width = Rozmiar;
PaintBox1->Height = Rozmiar;

TrackBar1->Top = 0;
TrackBar1->Height = Rozmiar + Panel1->Height;
TrackBar1->Left = Rozmiar;

Panel1->Width = Rozmiar;
Panel1->Left = 0;
Panel1->Top = Rozmiar;
SpeedButton1->Width = Panel1->Width;
SpeedButton1->Height = Panel1->Height;

ClientWidth = Rozmiar + TrackBar1->Width;
ClientHeight = Rozmiar + Panel1->Height;

MemBitmap = new Graphics::TBitmap;
MemBitmap->Width  = Rozmiar;
MemBitmap->Height = Rozmiar;
MemBitmap->PixelFormat=pf24bit;

var = 6;
a = 0;
b = 2;
c = 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintBox1Paint(TObject *Sender)
{

  //ponisza ptla rysuje palet kolorw na tymczasowej bitmapie
for (int y = 0; y < Rozmiar ;y++)
 {
    BYTE* rowPtr1=(BYTE*)MemBitmap->ScanLine[y];
  for (int x = 0; x < Rozmiar; x++)
      {
    BYTE* pixelPtr1=rowPtr1+x*3;
    pixelPtr1[a] = TrackBar1->Position;
    pixelPtr1[b] = x * Dzielnik;
    pixelPtr1[c] = y * Dzielnik;
   }
 }

 //tymczasowa bitmapa zostaje przekopiowana na PaintBox1
 PaintBox1->Canvas->Draw(0,0,MemBitmap);
}
//---------------------------------------------------------------------------



void __fastcall TForm1::PaintBox1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{

//zmienna Kolor tyu AnsiString przechowuje
//kolor w postaci heksadecymalnej

 Kolor = IntToHex((int) PaintBox1->Canvas->Pixels[X][Y], 6);

 //w zalenoci od opcji wywietla kolor w rnych formatach
 if (bcb->Checked) Label1->Caption = "$00" + Kolor;
 else if (homesite->Checked) Label1->Caption = "#" + ToHomeSite(Kolor);
 else Label1->Caption = Kolor;
 //jeeli nie ma blokady to zmienia na bieco kolor Panel1
 if (!Kopiuj->Checked && !Blokada) Panel1->Color =  ("$00" + Kolor).ToInt();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintBox1Click(TObject *Sender)
{
Panel1->Color =  ("0x" + Kolor).ToInt();
SpeedButton1->Hint = Label1->Caption;

//jeeli trzeba to kopiuje kolor do schowka
if (Kopiuj->Checked) DoSchowka();
else Blokada = !Blokada;
}
//---------------------------------------------------------------------------
//trzy ponisze funkcje obsuguj podrczne menu
//---------------------------------------------------------------------------

void __fastcall TForm1::KopiujClick(TObject *Sender)
{
Kopiuj->Checked = !Kopiuj->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bcbClick(TObject *Sender)
{
if (!bcb->Checked)
 {
  bcb->Checked = true;
  homesite->Checked = false;
 }
else bcb->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::homesiteClick(TObject *Sender)
{
if (!homesite->Checked)
 {
  bcb->Checked = false;
  homesite->Checked = true;
 }
else homesite->Checked = false;

}
//---------------------------------------------------------------------------

//funkcja kopiujca kolor do schowka
void TForm1::DoSchowka(void)
{
  AnsiString kolor = Label1->Caption;
  char *c = kolor.c_str();
  Clipboard()->SetTextBuf(c);
}


void __fastcall TForm1::FormDestroy(TObject *Sender)
{
//kasujemy bitmap z pamici
  delete MemBitmap;
}
//---------------------------------------------------------------------------
//ponisza funkcja konwertuje kolor na format HomeSite'a
AnsiString TForm1::ToHomeSite(AnsiString kol)
{
 int tColor = ("0x" + kol).ToInt();

  BYTE nRed   = GetRValue(tColor);
  BYTE nBlue  = GetBValue(tColor);
  BYTE nGreen = GetGValue(tColor);

 long temp = nRed * 65536 + nGreen * 256 + nBlue;
 kol = IntToHex((int)temp, 6);

 return kol;
}

//-------------------------------------------------------------
//wybieranie rodzaju palety
void __fastcall TForm1::SpeedButton1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (Button == mbRight)
 {
   if (++var > 6) var = 1;

   switch (var)
   {
    case 1:

     a = 0;
     b = 1;
     c = 2;
     break;

    case 2:
     a = 2;
     b = 1;
     c = 0;
     break;

    case 3:
     a = 2;
     b = 0;
     c = 1;
     break;

    case 4:
     a = 1;
     b = 0;
     c = 2;
     break;

     case 5:
     a = 1;
     b = 2;
     c = 0;
     break;

     case 6:
     a = 0;
     b = 2;
     c = 1;
     break;
}
 PaintBox1->Repaint();
 }
else if (Button == mbLeft) DoSchowka();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
//Przerysowuje palet przy zmianie pozycji suwaka
PaintBox1->Repaint();

}
//---------------------------------------------------------------------------

